
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>工厂方法VS构造器 / 憋错料</title>

    <meta name="description" content="工厂方法VS构造器 在java中工厂方法一般为静态方法,看下面的一个例子: package bb.cc; import java.io.PrintStream; import java.text.NumberFormat; public class MyTool { public static void main(String[] args) { NumberFormat currentFormat=NumberFormat.getCurrencyInstance(); NumberFormat percentFo">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">工厂方法VS构造器</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>在java中工厂方法一般为静态方法,看下面的一个例子：</p>
<pre>package bb.cc;

import java.io.PrintStream;
import java.text.NumberFormat;

public class MyTool {
      public static void main(String[] args) {
        NumberFormat currentFormat=NumberFormat.getCurrencyInstance();
        NumberFormat percentFormat=NumberFormat.getPercentInstance();
        double x=0.1;
        System.out.println(currentFormat.format(x));
        System.out.println(percentFormat.format(x));
    }
}</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzkxMjA0My8yMDE3MDMvOTEyMDQzLTIwMTcwMzA1MTMzNzMxNDA3LTE4OTc4ODM3Ni5wbmc=.jpg"></p>
<p>在这种设计模式下,构造器已经被静态方法碾压。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 07:15:43 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/form/" title="form">form</a>, <a href="https://www.biecuoliao.com/tag/%e5%88%86%e4%ba%ab/" title="分享">分享</a>, <a href="https://www.biecuoliao.com/tag/image/" title="image">image</a>, <a href="https://www.biecuoliao.com/tag/str/" title="str">str</a>, <a href="https://www.biecuoliao.com/tag/port/" title="port">port</a>, <a href="https://www.biecuoliao.com/tag/bsp/" title="bsp">bsp</a>, <a href="https://www.biecuoliao.com/tag/get/" title="get">get</a>, <a href="https://www.biecuoliao.com/tag/size/" title="size">size</a>, <a href="https://www.biecuoliao.com/tag/rgs/" title="rgs">rgs</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>工厂方法VS构造器的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MXYzLk0.html" rel="bookmark">Effective JAVA NO1考虑用静态工厂方法代替构造器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				NO1.考虑用静态工厂方法代替构造器 静态工厂方法与构造器不同的第一大优势在于它们有名称: 静态工厂方法与构造器不同的第二大优势在于,不必在每次调用它们的时候都创建一个新对象: 第三大优势,它们可以返回原返回类型的任何子类型的对象: 第四大优势,在创建参数化类型实例的时候,它们使代码变得更加简洁: 缺点: 1.类如果含公有的或者受保护的构造器,就不能被子类化. 2.它们与其他的静态方法实际不上没有任何区别.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4QWk7o0.html" rel="bookmark">&lbrack;Effective Java&rsqb;考虑用静态工厂方法代替构造器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文主要介绍如何使用静态工厂方法已经在那种场合来使用这种方式代替构造方法. 众所周知,对于类而言,我们为了获得一个类的实例对象,通常情况下会提供一个公有的(public) 的构造器.当然除了这种方法以外,我们还可以通过给类提供一个public的静态工厂方法(static factory method)的方式来完成,让它返回一个类的实例. 先看一个简单的Boolean的示例,这个示例将boolean基本类型值转换成一个Boolean对象的引用. public static Boolean valu			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xRYgn4.html" rel="bookmark">第二章、创建和销毁对象。ITEM1：考虑用静态工厂方法代替构造器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				除了使用构造器来获取类的一个实例,还可以使用静态工厂方法(static factory method). 下面的方法是将boolean基本类型转成一个Boolean对象引用: 1 public final class Boolean implements java.io.Serializable, 2 Comparable&lt;Boolean&gt; 3 { 4 //与基本类型boolean=true匹配 5 public static final Boolean TRUE = new Boolean(			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0aDdnRM.html" rel="bookmark">Effective java读书札记第一条之 考虑用静态工厂方法代替构造器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				对于类而言,为了让客户端获取它资深的一个实例,最常用的方法就是提供一个共有的构造器.还有一种放你发,也应该子每个程序员的工具箱中占有一席之地.类可以提供一个共有的静态 工厂方法,它只是返回类的实例的静态方法. 类可以通过静态工厂方法类提供它的客户端(对象),而不是通过构造器.提这样做的好处有: 1.静态工厂方法与构造器不同的第一大优势在于,它们有名称.比如构造器BigInteger(int,int,Random)返回的BigInteger可能为素数,如果用名为BigInteger.probabl			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MXvn8b3.html" rel="bookmark">【代码优化】考虑使用静态工厂方法取代构造器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				静态工厂方法与设计模式中的工厂方法模式不同,和设计模式中的工厂方法模式不直接相应. 使用静态工厂方法比构造器的优势: 第一.静态工厂方法是有名称的,而构造器是通过參数推断的. 每一个静态工厂方法都有自己的名字,能够依据名称就能够推断它要做什么事情,而构造器是做不到的. 如:构造器BigInteger(int,int),返回BigInteger能够是素数,偶数等.而用名称BigInteger.probalePrime的静态工厂方法 就一目了然了,代码easy阅读. 第二.不必再每次调用时候都创建一			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0lkPPEM.html" rel="bookmark">Efflective Java读书笔记 第一条 考虑用静态工厂方法代替构造器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				创建一个类的实例的方法,最常用的是提供一个公有[public]的构造器,另外还有一种方法是类可以提供一个公有的静态工厂方法. 静态工厂方法对于构造器有着不同的优势和劣势. 优势: 1.静态工厂方法可定义更有意思的名称,而构造函数只能是类名. eg:BigInteger的构造函数返回的可能是素数,不过使用BigInteger.probablePrime更加明确. 2.静态工厂方法不必没有调用的时候都创建一个新的对象,这对于不可变类可以预先构造好实例,调用时静态工厂方法直接返回即可. eg:Bool			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmYp6PM.html" rel="bookmark">Effective Java 读书笔记（一）：使用静态工厂方法代替构造器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这是Effective Java第2章提出的第一条建议: 考虑用静态工厂方法代替构造器 此处的静态工厂方法并不是设计模式,主要指static修饰的静态方法,关于static的说明可以参考之前的博文&lt;java中final与static的使用场景总结&gt;. 什么是静态工厂方法? 可以参考书中的例子(摘自JDK1.7 java.lang.Boolean) public final class Boolean implements java.io.Serializable, Comparable&lt;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0Yqwwr0.html" rel="bookmark">改善JAVA代码01：考虑静态工厂方法代替构造器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 系列文章:[传送门]   每次开始新的一本书,我都会很开心.新书新心情. 正文 静态工厂方法代替构造器 说起这个,好多可以念叨的.做了一年多的项目,慢慢也有感触. 说起构造器 大家很明白,构造器可以让我们在何处何地获取自身或者他人一个实例.我们是无忌惮的使用着 new 却从来没考虑过人家的感受.其实new ,new一个对象,就是开辟一块内存空间给这个对象.如果何处何地,都new的话,漫山遍野... 五颜六色的new ,本质却一样 一句话:构造器虽是万能,但是要珍惜. 再谈谈 静态工厂方法			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3OyYWXM.html" rel="bookmark">静态工厂方法VS构造器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				我之前已经介绍过关于构建者模式(Builder Pattern)的一些内容,它是一种很有用的模式用于实例化包含几个属性(可选的)的类,带来的好处是更容易读.写及维护客户端代码.今天,我将继续介绍对象创建技术. 在我看来,下面这个类是非常有用的例子.有一个RandomIntGenerator 类,产生随机的int类型的整数.如下所示: public class RandomIntGenerator { private final int min; private final int max; pu			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Moraey4.html" rel="bookmark">【代码优化】考虑使用静态工厂方法代替构造器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				静态工厂方法与设计模式中的工厂方法模式不同,和设计模式中的工厂方法模式不直接对应. 使用静态工厂方法比构造器的优势: 第一.静态工厂方法是有名称的,而构造器是通过参数判断的. 每个静态工厂方法都有自己的名字,可以根据名称就可以判断它要做什么事情,而构造器是做不到的. 如:构造器BigInteger(int,int),返回BigInteger可以是素数,偶数等,而用名称BigInteger.probalePrime的静态工厂方法 就一目了然了,代码容易阅读. 第二.不必再每次调用时候都创建一个新的			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/kML9jE0.html" rel="bookmark" class="title">bzoj3994 &lbrack;SDOI2015&rsqb;约数个数和</a>
					<div>
						传送门:http://www.lydsy.com/JudgeOnline/problem.php?id=3994 [题解] 这是一个比较重要的等式,反演常见套路之一: 那么有了这个等式我们就可以感性推 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QW7EL0.html" rel="bookmark" class="title">工资的差距是怎么来的</a>
					<div>
						曾有个月薪三千的女孩子,编的稿件漏洞百出,老板怒拍桌子,她却回了句:&quot;一个月三千块工资,你还想怎么样!&quot;琢磨她这话挺有意思,就像我们买了件便宜货,用不了两天就坏了,于是宽慰自己:就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/388Z5n3.html" rel="bookmark" class="title">HDU--2019</a>
					<div>
						数列有序! Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Subm ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyjWwE0.html" rel="bookmark" class="title">回车，换行 表示法（chr，ascii）</a>
					<div>
						chr(13) 是一个回车    chr(10) 是个换行符 ascii函数将字符转换成其对应的ascii码, chr函数将数字(acscii码)转换成对应的字符. 回车和换行的区别 在ASCII中, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nv8NK0.html" rel="bookmark" class="title">Daily Scrum 11&period;7</a>
					<div>
						明后两天周六日,按照TFS的日常安排应该是休息,所以让他们自由完成已经分配的任务. 姓名 今日任务 黄新越 提取爬取网页的关键字并输出到接口 刘垚鹏 程序总架构的修改与多线程的学习 王骜 多线程学习  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kDABj3.html" rel="bookmark" class="title">基数排序段错误</a>
					<div>
						本博客的代码的思想和图片参考:好大学慕课浙江大学陈越老师.何钦铭老师的&lt;数据结构&gt; 下面是是我的代码 1 /* 2 * radixSortLSD.c 3 * Implement radix ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGaelQ3.html" rel="bookmark" class="title">解压版tomcat配置</a>
					<div>
						1,新建变量名:CATALINA_BASE,变量值:E:\apache-tomcat-6.0.41(tomcat的解压路径) 2,新建变量名:CATALINA_HOME,变量值:E:\apache-t ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qajr53.html" rel="bookmark" class="title">时序图、流程图</a>
					<div>
						时序图是交互图的一种. 时序图和交互图都描述了软件的动态特征,是软件处理业务逻辑能力的体现. 流程图面向业务逻辑,不涉及软件内部的组件和结构,不涉及业务逻辑处理的参与者,只考虑业务处理的步骤及流程.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLP1xWM.html" rel="bookmark" class="title">poj3696       快速幂的优化&plus;欧拉函数&plus;gcd的优化&plus;互质</a>
					<div>
						这题满满的黑科技orz 题意:给出L,要求求出最小的全部由8组成的数(eg: 8,88,888,8888,88888,.......),且这个数是L的倍数 sol:全部由8组成的数可以这样表示:((1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NjzNV4.html" rel="bookmark" class="title">2017-9-8</a>
					<div>
						1.数字图像:B,G,R的空间坐标(X,Y)和亮度函数F(X,Y)成有限的,离散的值,这幅图像成为数字图像,可用一系列二位数组来表示,每一个二位数组表示一个颜色分量. 2.像素(pixel):数字化的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ko7rP0.html" rel="bookmark" class="title">每日一大片之忍者神龟变种时代</a>
					<div>
						忍者神龟变种时代BD 主演:梅根·福克斯  阿伦·瑞奇森  诺尔·费舍  皮特·普劳泽克  杰瑞米·霍华德  威尔·阿奈特   类型:动作片 导演:乔纳森·理贝斯曼   地区:美国 年份:2014 语 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pPxzw4.html" rel="bookmark" class="title">manacher求最长回文子串算法模板</a>
					<div>
						#include &lt;iostream&gt; #include &lt;cstring&gt; #include &lt;cstdlib&gt; #include &lt;stdio.h&gt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qRG7N4.html" rel="bookmark" class="title">在64位Win7中使用Navicat Premium 和PL&bsol;SQL Developer连接Oracle数据库备忘</a>
					<div>
						最近接手了一个项目,服务器端数据库是oracle 11g 64位.由于主要工作不是开发,也不想在自己的电脑上安装庞大的oracle数据库,因此寻思着只通过数据库管理工具连接数据库进行一些常用的查询操作 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vBQZX3.html" rel="bookmark" class="title">Html5工具</a>
					<div>
						HTML5被看做是web开发者创建流行web应用的利器,增加了对视频和Canvas 2D的支持.用HTML5的优点主要在于,这个技术可以进行跨平台的使用.比如你开发了一款HTML5的游戏,你可以很轻易 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBWY8Y0.html" rel="bookmark" class="title">对摄像头进行标定</a>
					<div>
						转自 http://wiki.opencv.org.cn/index.php/%E6%91%84%E5%83%8F%E5%A4%B4%E6%A0%87%E5%AE%9A 摄像头标定 目录 [隐藏] 1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jLar74.html" rel="bookmark" class="title">html函数联系，新中国成立</a>
					<div>
						&lt;!DOCTYPE html PUBLIC &quot;-//W3C//DTD XHTML 1.0 Transitional//EN&quot; &quot;http://www.w3.org/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49kYpp0.html" rel="bookmark" class="title">iOS学习之C语言Day03</a>
					<div>
						1.while循环 while (循环条件) {        循环体:    }    // 1.定义循环变量    int time = 1;    // 2.循环条件    while (tim ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35NQG14.html" rel="bookmark" class="title">C&num; 编码约定</a>
					<div>
						参考自 MSDN     https://msdn.microsoft.com/zh-cn/library/ff926074.aspx , 只摘要个人觉得有用部分 命名约定 在不包括 using 指令 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QvgKoM.html" rel="bookmark" class="title">帝国cms数据还原后提示数据库表不存在怎么解决&quest;</a>
					<div>
						下午,ytkah用帝国cms在wamp调试时发现了一个问题,还原备份好的数据后更新的页面提示数据库表不存在,查看了phpmyadmin分类的数据库表实际上是存在的,这个是怎么回事呢?重新搭建一个新站点 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVRlZ1M.html" rel="bookmark" class="title">POJ1088：滑雪&lpar;记忆化&rpar;</a>
					<div>
						Description Michael喜欢滑雪百这并不奇怪, 因为滑雪的确很刺激.可是为了获得速度,滑的区域必须向下倾斜,而且当你滑到坡底,你不得不再次走上坡或者等待升降机来载你.Michael想知道 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.023 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
